package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.*;
import com.xylink.sdk.distributor.DistributorApi;
import com.xylink.util.RandomValue;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.fail;

/**
 * Created with IntelliJ IDEA.
 * Description:
 * User: gzm
 * Date: 2019-04-26
 */
public class DistributorTest extends EnterpriseConfig {


    private String distributorid = "xxx";

    @Test
    public void addEnterprise() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.addEnterprise(distributorid, token,
                    RandomValue.getBuffetAddEnterpriseReq());
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void modifyEnterprise() {
        DistributorApi distributorApi = new DistributorApi();
        BuffetAddEnterpriseReq buffetAddEnterpriseReq = new BuffetAddEnterpriseReq();
        buffetAddEnterpriseReq.setAdminName("adminName1");
        buffetAddEnterpriseReq.setCity("长安");
        buffetAddEnterpriseReq.setContactNumber("contactname1");
        buffetAddEnterpriseReq.setCountry("中国");
        buffetAddEnterpriseReq.setCountryCode("86");
        buffetAddEnterpriseReq.setDetailAddress("长安街");
        buffetAddEnterpriseReq.setProvince("南京市");
        buffetAddEnterpriseReq.setDistrict("---");
        buffetAddEnterpriseReq.setIndustry("01");
        buffetAddEnterpriseReq.setMailbox(RandomValue.getEmail(3,7));
        buffetAddEnterpriseReq.setName(RandomValue.getChineseName());
        buffetAddEnterpriseReq.setPhone(RandomValue.getTel());
        buffetAddEnterpriseReq.setPhoneCountryCode("+86");
        try {
            Result result = distributorApi.modifyEnterprise(distributorid,enterpriseId, token,
                    buffetAddEnterpriseReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }


    @Test
    public void getEnterprises() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getEnterprises(distributorid, token,
                    0,20);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void batchUsers() {
        DistributorApi distributorApi = new DistributorApi();
        List<EnterpriseUserReq> enterpriseUserReqs = new ArrayList<EnterpriseUserReq>();
        for (int i=0;i<1;i++){
            enterpriseUserReqs.add(RandomValue.getEnterpriseUserReq(enterpriseId));
        }
        try {
            Result result = distributorApi.batchEnterpriseUsers(distributorid, token, enterpriseUserReqs);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void modifyUsers() {
        DistributorApi distributorApi = new DistributorApi();
        String userProfileId = "23324503";
        UserReq user = new UserReq(enterpriseId,userProfileId,"mdifyname2");
        try {
            Result result = distributorApi.modifyUser(distributorid, token, user);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getUsers() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getUsers(distributorid, token,enterpriseId,0,20);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getUserByUserId() {
        DistributorApi distributorApi = new DistributorApi();
        String userProfileId = "23324503";
        try {
            Result result = distributorApi.getUserByUserId(distributorid, token,userProfileId);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void deleteUserByUserId() {
        DistributorApi distributorApi = new DistributorApi();
        String userProfileId = "23324503";
        try {
            Result result = distributorApi.deleteUserByUserId(distributorid, token,userProfileId);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    //===================//

    @Test
    public void getNemosPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getNemosPage(distributorid, token,enterpriseId,false,0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getDevicesInfoPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getDevicesInfoPage(distributorid, token,enterpriseId,0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void editDevice() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.editDevice(distributorid, token,enterpriseId,"607537","测试修改name6");
//            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void addDevice() {
        DistributorApi distributorApi = new DistributorApi();
        List<UserDeviceDto> userDeviceDtos =  new ArrayList<UserDeviceDto>();
        UserDeviceDto userDeviceDto = new UserDeviceDto();
        userDeviceDto.setEnterpriseId(enterpriseId);
        userDeviceDto.setDisplayName("测试添加通讯录");
        userDeviceDto.setNemoNumber("607537");
        userDeviceDtos.add(userDeviceDto);
        try {
            Result result = distributorApi.addDevice(distributorid, token,enterpriseId,userDeviceDtos);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void removeDevice() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.removeDevice(distributorid, token,enterpriseId,"941242");
//            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getNemoMeetingPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getNemoMeetingPage(distributorid, token,enterpriseId,"471207",1562307148l,System.currentTimeMillis(),0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getConferenceCurrentMeetingPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getConferenceCurrentMeetingPage(distributorid, token,enterpriseId,"910087475352",0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getEnterpriseCurrentMeetingPage() {
        DistributorApi distributorApi = new DistributorApi();
        try {
            Result result = distributorApi.getEnterpriseCurrentMeetingPage(distributorid, token,enterpriseId,0,10);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void addUserAdmin() {
        DistributorApi distributorApi = new DistributorApi();
        UserAdminReq userAdminReq = new UserAdminReq(enterpriseId,"18866674211");
        System.out.println("addUserAdmin:"+userAdminReq);
        try {
            Result result = distributorApi.addUserAdmin(distributorid, token,userAdminReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void updateUserAdmin() {
        DistributorApi distributorApi = new DistributorApi();
        UserAdminReq userAdminReq = new UserAdminReq(enterpriseId,"13601472054");
        try {
            Result result = distributorApi.updateUserAdmin(distributorid, token,userAdminReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void deleteUserAdmin() {
        DistributorApi distributorApi = new DistributorApi();
        UserAdminReq userAdminReq = new UserAdminReq(enterpriseId,"13601472054");
        userAdminReq.setPhone("");
        try {
            Result result = distributorApi.deleteUserAdmin(distributorid, token,userAdminReq);
            System.out.println("responds:" + result.getData().toString());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }
}
