package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.Pager;
import com.xylink.model.ReminderMeeting;
import com.xylink.sdk.conferenceControl.CloudMeetingRoomApi;
import com.xylink.sdk.dating.ScheduleMeetingApi;
import com.xylink.util.Result;
import com.xylink.util.SignatureSample;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.Set;
import java.util.TreeSet;

import static org.junit.Assert.fail;

/**
 * Created by changxiangyang on 2017/9/19.
 */
public class ScheduleMeetingTest extends EnterpriseConfig{

    //预约会议
    @Test
    public void remindMeeting(){

        Set<String> ps = new TreeSet<String>();
        Set<String> sps = new TreeSet<String>();
//        ps.add("23869749");
//        ps.add("846240");
//        ps.add("12346068753");
//        ps.add("13811083892");

//        sps.add("846240");
        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        ReminderMeeting reminderMeeting=new ReminderMeeting();
        reminderMeeting.setTitle("testtesttest");
        reminderMeeting.setStartTime(System.currentTimeMillis() + (1000 * 60 * 1));
        reminderMeeting.setEndTime(System.currentTimeMillis() + (1000 * 60 * 60));
        reminderMeeting.setAddress("地中海");
        reminderMeeting.setAutoInvite(1);
        reminderMeeting.setPassword("0000");
        reminderMeeting.setMeetingRoomType(1);
        reminderMeeting.setAutoRecord(0);
        reminderMeeting.setParticipants(ps);
        reminderMeeting.setSingleRecordParticipants(sps);
        reminderMeeting.setConferenceNumber("9000637037");
        try {
            Result result = sma.remindMeeting(enterpriseId, token, reminderMeeting);
            System.out.println(result);
            //如成功后的一个示例：{"success":true,"errorStatus":200,"data":{"meetingId":"ff80808165a02ba20165cc92ef9b542c","meetingRoomNumber":"956401821"}}
        }catch (IOException e){
            System.out.println("testRemindMeeting--"+e);
        }
    }
    //修改预约会议 TODO 会议id和会议号必须是合法的，可以通过remindMeeting()方法先预约会议
    @Test
    public void updateMeeting(){
        Set<String> ps = new TreeSet<String>();
        Set<String> sps = new TreeSet<String>();
        ps.add("23869749");
        ps.add("23896157");
        ps.add("13810090687");
        ps.add("13811083892");

        sps.add("10837801");
        sps.add("13811083892");

        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        ReminderMeeting reminderMeeting=new ReminderMeeting();
        reminderMeeting.setTitle("预约会议update");
        reminderMeeting.setStartTime(System.currentTimeMillis() + (1000 * 60 * 4));
        reminderMeeting.setEndTime(System.currentTimeMillis() + (1000 * 60 * 6));
        reminderMeeting.setConferenceNumber(meetingRoomNumber);
        reminderMeeting.setAddress("地中海");
        reminderMeeting.setAutoInvite(1);
        reminderMeeting.setPassword("2345");
        reminderMeeting.setAutoRecord(0);
        reminderMeeting.setSingleRecordParticipants(sps);
        reminderMeeting.setParticipants(ps);

        try {
            Result result = sma.updateMeeting(enterpriseId, token, meetingId, reminderMeeting);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    //删除会议 TODO 会议id必须有效
    @Test
    public void deleteMeeting(){
        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        try {
            Result result = sma.deleteMeeting(enterpriseId, token, meetingId);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }
    //按照结束时间获取会议
    @Test
    public void getAllMeeting(){
        ScheduleMeetingApi sma=new ScheduleMeetingApi();
        long endtime = 0;
        try {
            Result<ReminderMeeting[]> allMeeting = sma.getAllMeeting(enterpriseId, token, endtime);
            System.out.println(allMeeting);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    @Test
    public void getMeetingByPage() {
        ScheduleMeetingApi scheduleMeetingApi = new ScheduleMeetingApi();
        int page = 0;
        int size = 50;
        long endTime = 0;
        Result<Pager<ReminderMeeting>> result;

        try {
            result = scheduleMeetingApi.getMeeting(enterpriseId, token, page, size, endTime);
            System.out.println(result);
        } catch (IOException e) {
            System.out.println(e);
        }
    }

    @Test
    public void getMeetingByNumberPage() {
        ScheduleMeetingApi scheduleMeetingApi = new ScheduleMeetingApi();

        int page = 0;
        int size = 50;
        Result<Pager> result;
        try {
            result = scheduleMeetingApi.getMeetingByConfrenceNumber(enterpriseId, token, page, size, "9797");
            System.out.println(result);
        } catch (IOException e) {
            System.out.println(e);
        }
    }

}
